/**
 * MagicSquareChecker enables user to check
 * if a given square of integers is a Magic Square.
 * All methods are static.
 */
public class MagicSquareChecker {
	/**
	* Checks if a given s Square matrix is a magic square
	* @return boolean - true if the given matrix is a magic square
	*   			    false otherwise 	
	*/
	public static boolean isMgSquare(int[][] mat){
    int firstRowSum = ArrayUtil.getSum(mat[0]);
    if((isDiagonalsEqualsSum(firstRowSum, mat)) && (isRowsEqualsSum(firstRowSum,mat))&& (isColEqualsSum(firstRowSum,mat))){
    	return true;// this is a magic Sq
    }
    else{
      return false; // this is not a magic Sq
    }
  }

  private static boolean isDiagonalsEqualsSum(int sum, int[][] matrix){
    int primaryDiagonalSum = ArrayUtil.leftDiagonalSum(matrix);
    int secondaryDiagonalSum = ArrayUtil.rightDiagonalSum(matrix);
    if((sum == primaryDiagonalSum)&&(sum == secondaryDiagonalSum)){
      return true;
    }
    else{
      return true;
    }
  }

  private static boolean isRowsEqualsSum(int sum,int[][] matrix){
	//we start from row 1 because we know the sum of zero's row (sum parameter)
	for(int i=1; i<matrix.length; i++) { 
    	int currentSum = ArrayUtil.getSum(matrix[i]);
    	if(sum != currentSum){
    		return false;
        }
    }//for
    return true;
  }

  private static boolean isColEqualsSum(int sum,int[][] matrix){
    //check columns sum
    int sqSize = matrix.length;
    for(int i=0; i < sqSize; i++){
      int columnSum = 0;
      for(int j=0; j < sqSize; j++)
        columnSum+= matrix[j][i];
        if(sum != columnSum)
          return false;
    }//for
    return true;
  }//close isColEqualsSum
}//close class
