/**
 * This is a MagicSquareGame. It enables the user to
 * compose a square of integers and check if this square 
 * is a magic square.
 * Description:  A magic square is an arrangement of the numbers
 * from 1 to n^2 (n-squared) in an nxn matrix, with each number
 * occurring exactly once, and such that the sum of the entries
 * of any row, any column, or any main diagonal is the same.
 * It is not hard to show that this sum must be n(n^2+1)/2
 * @Author: Yuval Vidal
 */
public class MagicSquareGame {
	
	public static void main(String[] args) {
    OutputWindow.println("Try To make a Magic Square.");
    SquareRequestor  sgRequest = new SquareRequestor();
    int[][] matToCheck = sgRequest.getSquare();
    if(MagicSquareChecker.isMgSquare(matToCheck)){
    	OutputWindow.println("YES! You got a Magic Square!");
    	OutputWindow.println("To end game click Exit button.");
    }
    else{
      OutputWindow.println("NO This is not a Magic Square.");
      OutputWindow.println("To end game click Exit button.");
    }
  }//close main
}//close class
