/**
public class ArrayUtil extends Object.
@see Object
The class ArrayUtil contains static methods for performing basic operations
on arrays such as printing an array of integers, calculating the sum of
integers in array, calculating the average number,sorting numbers, printing
a 2D array of integers, calculating the sum of the left/right diagonal of
2D array of integers and more.
@author Yuval Vidal
*/
public class ArrayUtil {
	
		
	/**
	 * Print members of array to System.out.
	 */
	public static void printArray(int[] array) {
		for (int i=0; i<array.length; i++)
			System.out.print(array[i]+" ");
		System.out.println();
	}

	/**
	 * Sum the members of array.
	 */
	public static int getSum(int[] array) {
		int sum=0;
		for (int i=0; i<array.length; i++)
			sum+=array[i];
		return sum;
	}




	/**
	 * Finds the longest string in a given array.
	 * If two or more are the "longest" return the first one in the array.
	 * @return String the longest string (the first one).
	 */
	public static String getLongest(String[] arrayOfStrings){
		int longest =0;
	    int longestIndex = 0;
    	for(int i=0; i<arrayOfStrings.length; i++) {
			int current = (arrayOfStrings[i]).length();
			if(current > longest) {
				longest = current;
				longestIndex = i;
			}
		}
		return arrayOfStrings[longestIndex];
	}

	/**
		Print members of 2D array to System.out.
	*/
	public static void printArray(int[][] array) {
		for (int i=0; i<array.length; i++)
			printArray(array[i]);
	}
  
	/**
		Calculate left diagonal sum of 2D array.
		Note: no cheking is performed that input array is indeed square matrix.
	*/
	public static int leftDiagonalSum(int[][] array) {
		int sum=0;
		for (int i=0; i<array.length; i++)
			sum+=array[i][i];
		return sum;
	}

	/**
		Calculate right diagonal sum of 2D array.
		Note: no cheking is performed that input array is indeed square matrix.
	*/
	public static int rightDiagonalSum(int[][] array) {
		int sum=0;
		int n=array.length-1;
		for (int i=0; i<array.length; i++)
			sum+=array[n-i][i];
		return sum;
	}

  

}//close class
