import java.awt.*;

public class MagControls extends Panel {
	SquareRequestor outerparent;
	Font control_font;
	Choice level;
	TextField number = new TextField(3);
	//Button colors;
	Button getBtn;
	//ColorsWindow colors_window;
	Color fgcontrols, bgcontrols;
	
	String comments =
									 "This is an Applet created by Michael W.S. Morton for the Math Forum. Any \n" +
									 "pieces of code may be used only with consent of the Math Forum. The \n" +
									 "instructions for this Magic Square are at: \n" +
									 "http://forum.swarthmore.edu/workshops/sum96/magic.squares.html \n" +
									 "This Applet is still under construction, and I would appreciate any \n" +
									 "comments/suggestions; please send to Mike Morton: \n"+
									 "\t\tmorton@forum.swarthmore.edu. \n"+
									 "Enjoy.";
	
	MagControls(SquareRequestor target) {
		this.outerparent = target;
		
		//Setup Colors
		fgcontrols = Color.black;
		bgcontrols = Color.white;
		setBackground(bgcontrols);
		
		//Trying to set Font for Controls
		control_font = new Font("TimesRoman", Font.PLAIN, 20);
		
		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();
		//c.fill = GridBagConstraints.BOTH;
   	   	c.gridwidth = GridBagConstraints.REMAINDER; //end row
   	 	Label l=new Label("Drag yellow numbers on the right to the grid. Click the O.K button to finish.");
   	    gridbag.setConstraints(l, c);
        add(l);
     

         
		c.gridwidth = 3; //GridBagConstraints.RELATIVE; 
        //c.weightx = 1.0;
        l=new Label("Select square size: ");
        gridbag.setConstraints(l, c);
		add(l); 
        
		//Setup Choice Menu
		level = new Choice();
		level.addItem("3");
		level.addItem("4");
		level.addItem("5");
		level.select("3");
		
		//Add Label + Choice Menu
		gridbag.setConstraints(level, c);
		add(level);
		
		//Setup Textfield 
		//add(new Label("Change number of selected box: "));
		//add(number);
		
		//Setup Buttons
		//colors = new Button("Show Colors Window");
		//add(colors);
		
		//Setup Colors Window
		//colors_window = new ColorsWindow(this);
		//colors_window.resize(125,200);
		
		getBtn = new Button("O.K");
		gridbag.setConstraints(getBtn, c);
		add(getBtn);
		
		// Add comments
		//add(new TextArea(comments,10,50));
		
	}
	
	//private synchronized void inputReceived(String input) {
	//	inputString = input;
	//	notifyAll();
	//}
	
	//Handle Clicks.
	public boolean action(Event evt, Object arg) {
		if (evt.target instanceof Choice) {
			//Check if level is clicked, and call the update_level function
			//in the JamCan class.
			if (evt.target == level) {
				outerparent.magcan.update_level((level.getSelectedIndex()) + 3);
			}
		}
		if (evt.target instanceof TextField) {
			outerparent.magcan.update_number(Integer.parseInt(number.getText()));
		}
		if (evt.target instanceof Button) {
			if(evt.target == getBtn) {
				if (outerparent.magcan.checkSquare())
					outerparent.magcan.n();
					//notifyAll();
				else
					new OkDialog(outerparent);
			}
		}
		/*    	
		if(evt.target == colors) {
		if(colors.getLabel().equals("Show Colors Window")) {
		colors_window.show();
		colors.setLabel("Hide Colors Window");
		}
		else if(colors.getLabel().equals("Hide Colors Window")) {
		colors_window.hide();
		colors.setLabel("Show Colors Window");
		}
		}
	}
		*/      	
	return true;
}
  
  void updatecolor(String choice, Color col) {
    if(choice.equals("fg"))
      fgcontrols = col;
    else if(choice.equals("bg"))
      bgcontrols = col;
    
    setBackground(bgcontrols);
    
    repaint();
  }	
  
class OkDialog extends Dialog {
	Button okBtn;
  final int WIDTH=180;
	final int HEIGHT=90;

	OkDialog(Frame f) {
		super(f, "Error", true);
		setLayout(new FlowLayout(FlowLayout.CENTER));
		//setLayout(new GridLayout(0,1));
		add(new Label("The square is not ready yet!"));
		add(okBtn=new Button("OK"));
		Rectangle r=f.getBounds();
		setBounds(r.x+(r.width-WIDTH)/2, r.y+(r.height-HEIGHT)/2, WIDTH, HEIGHT);
		setResizable(false);
		//pack();
		show();
	}

	public boolean action(Event event, Object arg) {
		if (event.target == okBtn) {
			dispose();
		}
		return true;
	}
}
  
}





